/*  ___   ___  ___  _   _  ___   ___   ____ ___  ____  
 * / _ \ /___)/ _ \| | | |/ _ \ / _ \ / ___) _ \|    \ 
 *| |_| |___ | |_| | |_| | |_| | |_| ( (__| |_| | | | |
 * \___/(___/ \___/ \__  |\___/ \___(_)____)___/|_|_|_|
 *                  (____/ 
 * Arduino Mecanum Omni Direction Wheel Robot Car lesson 3: Line Tracking
 * Tutorial URL http://osoyoo.com/2019/10/22/mecanum-omni-direction-wheel-robot-car-v2-0/
 * CopyRight www.osoyoo.com
 * 
 */
#define Left_Pin 2
#define Center_Pin 3
#define Right_Pin 4
 #define TURN_TIME  50 
#define MOVE_TIME  50   
 #define SPEED 190   
#define speedPinR 9   //  RIGHT WHEEL PWM pin D45 connect front MODEL-X ENA 
#define RightMotorDirPin1  22    //Front Right Motor direction pin 1 to Front MODEL-X IN1  (K1)
#define RightMotorDirPin2  24   //Front Right Motor direction pin 2 to Front MODEL-X IN2   (K1)                                 
#define LeftMotorDirPin1  26    //Left front Motor direction pin 1 to Front MODEL-X IN3 (  K3)
#define LeftMotorDirPin2  28   //Left front Motor direction pin 2 to Front MODEL-X IN4 (  K3)
#define speedPinL 10   // Left WHEEL PWM pin D7 connect front MODEL-X ENB

#define speedPinRB 11   //  RIGHT WHEEL PWM pin connect Back MODEL-X ENA 
#define RightMotorDirPin1B  5    //Rear Right Motor direction pin 1 to Back MODEL-X IN1 (  K1)
#define RightMotorDirPin2B 6    //Rear Right Motor direction pin 2 to Back MODEL-X IN2 (  K1) 
#define LeftMotorDirPin1B 7    //Rear left Motor direction pin 1 to Back MODEL-X IN3  K3
#define LeftMotorDirPin2B 8  //Rear left Motor direction pin 2 to Back MODEL-X IN4  k3
#define speedPinLB 12    //   LEFT WHEEL  PWM pin D8 connect Rear MODEL-X ENB

/*motor control*/
void right_shift(int speed) {
  FL_fwd(speed); 
  RL_bck(speed); 
  RR_fwd(speed);
  FR_bck(speed);
}
void left_shift(int speed){
   FL_bck(speed);
   RL_fwd(speed);
   RR_bck(speed);
   FR_fwd(speed);
}
void go_advance(int speed){
   RL_fwd(speed);
   RR_fwd(speed);
   FR_fwd(speed);
   FL_fwd(speed); 
}
void go_back(int speed){
   RL_bck(speed);
   RR_bck(speed);
   FR_bck(speed);
   FL_bck(speed); 
}
void left_turn(int speed){
   RL_bck(0);
   RR_fwd(speed);
   FR_fwd(speed);
   FL_bck(0); 
}
void right_turn(int speed){
   RL_fwd(speed);
   RR_bck(0);
   FR_bck(0);
   FL_fwd(speed); 
}
void left_back(int speed){
   RL_fwd(0);
   RR_bck(speed);
   FR_bck(speed);
   FL_fwd(0); 
}
void right_back(int speed){
   RL_bck(speed);
   RR_fwd(0);
   FR_fwd(0);
   FL_bck(speed); 
}


void FR_fwd(int speed)  //front-right wheel forward turn
{
  digitalWrite(RightMotorDirPin1, LOW);
  digitalWrite(RightMotorDirPin2,HIGH); 
  analogWrite(speedPinR,speed);
}
void FR_bck(int speed) // front-right wheel backward turn
{
  digitalWrite(RightMotorDirPin1,HIGH);
  digitalWrite(RightMotorDirPin2,LOW); 
  analogWrite(speedPinR,speed);
}
void FL_fwd(int speed) // front-left wheel forward turn
{
  digitalWrite(LeftMotorDirPin1,LOW);
  digitalWrite(LeftMotorDirPin2,HIGH);
  analogWrite(speedPinL,speed);
}
void FL_bck(int speed) // front-left wheel backward turn
{
  digitalWrite(LeftMotorDirPin1,HIGH);
  digitalWrite(LeftMotorDirPin2,LOW);
  analogWrite(speedPinL,speed);
}

void RR_fwd(int speed)  //rear-right wheel forward turn
{
  digitalWrite(RightMotorDirPin1B, LOW);
  digitalWrite(RightMotorDirPin2B,HIGH); 
  analogWrite(speedPinRB,speed);
}
void RR_bck(int speed)  //rear-right wheel backward turn
{
  digitalWrite(RightMotorDirPin1B, HIGH);
  digitalWrite(RightMotorDirPin2B,LOW); 
  analogWrite(speedPinRB,speed);
}
void RL_fwd(int speed)  //rear-left wheel forward turn
{
  digitalWrite(LeftMotorDirPin1B,LOW);
  digitalWrite(LeftMotorDirPin2B,HIGH);
  analogWrite(speedPinLB,speed);
}
void RL_bck(int speed)    //rear-left wheel backward turn
{
  digitalWrite(LeftMotorDirPin1B,HIGH);
  digitalWrite(LeftMotorDirPin2B,LOW);
  analogWrite(speedPinLB,speed);
}
 
 
void stop_Stop()    //Stop
{
     analogWrite(speedPinLB,0);
  analogWrite(speedPinRB,0);
    analogWrite(speedPinL,0);
  analogWrite(speedPinR,0);
}


//Pins initialize
void init_GPIO()
{
    pinMode(Left_Pin, INPUT); 
 pinMode(Center_Pin, INPUT); 
  pinMode(Right_Pin, INPUT); 
  
  pinMode(RightMotorDirPin1, OUTPUT); 
  pinMode(RightMotorDirPin2, OUTPUT); 
  pinMode(speedPinL, OUTPUT);  
 
  pinMode(LeftMotorDirPin1, OUTPUT);
  pinMode(LeftMotorDirPin2, OUTPUT); 
  pinMode(speedPinR, OUTPUT);
     pinMode(RightMotorDirPin1B, OUTPUT); 
  pinMode(RightMotorDirPin2B, OUTPUT); 
  pinMode(speedPinLB, OUTPUT);  
 
  pinMode(LeftMotorDirPin1B, OUTPUT);
  pinMode(LeftMotorDirPin2B, OUTPUT); 
  pinMode(speedPinRB, OUTPUT);
   
  pinMode(Left_Pin, INPUT);
  pinMode(Center_Pin, INPUT);
  pinMode(Right_Pin, INPUT);
}

void setup()
{
  init_GPIO();
  Serial.begin(9600);
  /*
  go_advance(SPEED);
  delay(1000);
  go_back(SPEED);
  delay(1000);
  stop_Stop();
  */
}

void loop(){
   
 auto_tracking();
}
String read_sensor_values()
{   int sensorvalue=8;
   int sensor_left,sensor_center,sensor_right;
  sensor_left= digitalRead(Left_Pin);
 
  sensor_center=digitalRead(Center_Pin);
 
  sensor_right=digitalRead(Right_Pin);
 
  sensorvalue +=sensor_left*4+sensor_center*2+sensor_right;
 
  String senstr= String(sensorvalue,BIN);
 
  return senstr.substring(1,4);
}
void auto_tracking(){
 String sensorval= read_sensor_values();
 Serial.println(sensorval);
 if (sensorval=="100" or sensorval=="110")
 { 
    //The black line is in the left of the car, need  left turn 
  Serial.println("TURN left");
      left_turn(SPEED);  //Turn right
      
    delay(TURN_TIME);
    stop_Stop();
   delay(50);
  
    }

 if (sensorval=="011" or sensorval=="001"){ 
     //The black line is  on the right of the car, need  right turn 
         right_turn(SPEED);  //Turn left
      Serial.println("TURN right");
 
           delay(TURN_TIME);
      stop_Stop();
      delay(50);
     
    }
  if (sensorval=="010" or sensorval=="101"){ 
    Serial.println("go ahead");
    go_advance(SPEED);
    delay(MOVE_TIME);
    stop_Stop();
    delay(50);
 
    }
 if (sensorval=="000" or sensorval=="111"){
    Serial.println("back");
          go_back(SPEED);
           delay(MOVE_TIME/3*2);
      stop_Stop();
      delay(50);
   
     
    }
 
}
